# HG changeset patch
# User Rudolph Gutzerhagen <rudolph.gutzerhagen@gmail.com>
# Date 1612356889 18000
#      Wed Feb 03 07:54:49 2021 -0500
# Node ID c85746edef74a801fb286143cc6b8577aa3ee01d
# Parent  304956259b1b6cd37843a47a3a94706fbf3b5f63
TYT TH-UV88 : changes to allow use of split "duplex" mode  #8747
N.B. Threshold on split vs offset is 25 MHz.

diff --git a/chirp/drivers/th_uv88.py b/chirp/drivers/th_uv88.py
--- a/chirp/drivers/th_uv88.py
+++ b/chirp/drivers/th_uv88.py
@@ -486,7 +486,7 @@
         rf.has_comment = False
         rf.has_tuning_step = False      # Not as chan feature
         rf.valid_tuning_steps = STEPS
-        rf.can_odd_split = False
+        rf.can_odd_split = True
         rf.has_name = True
         rf.has_offset = True
         rf.has_mode = True
@@ -499,7 +499,7 @@
         rf.valid_name_length = self.NAME_LENGTH
         rf.valid_modes = self.MODES
         rf.valid_characters = self.VALID_CHARS
-        rf.valid_duplexes = ["-", "+", "off", ""]
+        rf.valid_duplexes = ["", "-", "+", "split", "off"]
         rf.valid_tmodes = ['', 'Tone', 'TSQL', 'DTCS', 'Cross']
         rf.valid_cross_modes = ["Tone->Tone", "DTCS->", "->DTCS",
                                 "Tone->DTCS", "DTCS->Tone", "->Tone",
@@ -599,6 +599,9 @@
             # TX freq not set
             mem.duplex = "off"
             mem.offset = 0
+        elif abs(int(_mem.rxfreq) * 10 - int(_mem.txfreq) * 10) > 25000000:
+            mem.duplex = "split"
+            mem.offset = int(_mem.txfreq) * 10
         elif int(_mem.rxfreq) == int(_mem.txfreq):
             mem.duplex = ""
             mem.offset = 0
@@ -694,6 +697,8 @@
         _mem.rxfreq = mem.freq / 10
         if mem.duplex == "off":
             _mem.txfreq = 0xFFFFFFFF
+        elif mem.duplex == "split":
+            _mem.txfreq = mem.offset / 10
         elif mem.duplex == "+":
             _mem.txfreq = (mem.freq + mem.offset) / 10
         elif mem.duplex == "-":
